// Win32_OwnerDrawStaticControl.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "Win32_OwnerDrawStaticControl.h"
#include "commdlg.h" // colors dialog

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
HWND g_hwndStatic_OwnerDraw; 
HWND g_hwndButton;
COLORREF g_clrBackgroundColor = RGB(255, 0, 0);

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WIN32_OWNERDRAWSTATICCONTROL, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WIN32_OWNERDRAWSTATICCONTROL);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW; 
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_WIN32_OWNERDRAWSTATICCONTROL);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_WIN32_OWNERDRAWSTATICCONTROL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;

	hInst = hInstance; // Store instance handle in our global variable

	hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
	                           500, 400, 400, 200, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}

	// Static owner-draw control.
	g_hwndStatic_OwnerDraw =  CreateWindow("STATIC", NULL, 
		WS_CHILD | WS_VISIBLE | SS_OWNERDRAW | SS_SUNKEN, 
		       130, 50, 50, 50, hWnd, (HMENU)IDC_STATIC_OWNERDRAW, hInst, NULL);

	// Button that invokes color selection dialog. 
	RECT rcButton = {200, 50, 250, 100};
	g_hwndButton = CreateWindow("BUTTON", "", 
		WS_VISIBLE | WS_CHILD, 200, 50, 50, 50, hWnd, (HMENU)IDC_BUTTON, 
		                                                              hInst, 0);
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//  COMMENTS:
//
//  About painting from MSDN: "You should save the SelectObject return value 
//  because it is the handle to the default object. When you finish using the 
//  new object, use SelectObject to restore the default object, and delete the 
//  new object with the DeleteObject function." and "When you have finished 
//  drawing in the display area, you must release the device context by calling 
//  the EndPaint or ReleaseDC function. If you called BeginPaint to create the 
//  device context, then call EndPaint to release it. If you called GetDC to 
//  create the device context, then call ReleaseDC to release it."

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	LPDRAWITEMSTRUCT lpdis = NULL; 
	CHOOSECOLOR cc;         
	COLORREF acrCustClr[16]; // array of custom colors 
	int nSavedDC;
	HBRUSH hOldBrush;
    HBRUSH hBrush;         

	switch (message) 
	{	
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case IDC_BUTTON:
			// Initialize CHOOSECOLOR structure. 
			ZeroMemory(&cc, sizeof(CHOOSECOLOR));
			cc.lStructSize = sizeof(CHOOSECOLOR);
			cc.hwndOwner = hWnd;
			cc.lpCustColors = (LPDWORD) acrCustClr;
			cc.rgbResult = 0; // initialize/get selection (double use)
			cc.Flags = CC_FULLOPEN | CC_RGBINIT;

			if (ChooseColor(&cc) == TRUE)
			{
				// The g_clrBackgroundColor variable that stores color from 
				// color selection dialog should be global, not local, since
				// WM_DRAWITEM corresponding to owner-draw static control can be 
				// caused not only from here (RedrawWindow), but also due to 
				// main window resize, About dialog close.
				g_clrBackgroundColor = cc.rgbResult;

				// Cause WM_DRAWITEM to be sent to owner-draw static control
				// (actually to its parent window). One other option is to fill 
				// out DRAWITEMSTRUCT structure and send WM_DRAWITEM to static 
				// control with SendMessage explicitly.
				RedrawWindow(g_hwndStatic_OwnerDraw, 
					NULL /* invalidate entire client area */, 
					  NULL /* invalidate entire client area */, RDW_INVALIDATE);
			}
			break;
		default:
		    return DefWindowProc(hWnd, message, wParam, lParam);
		}
	case WM_DRAWITEM:
		// When WM_DRAWITEM message is received here, its wParam can correspond   
		// not only to ID of owner-draw static control, but also to button ID 
		// even though owner-draw style is set only for static control. Thus, 
		// sort out WM_DRAWITEM messages to handle messages pertaining only to
		// owner-draw static control. Without comparing wParam to 
		// IDC_STATIC_OWNERDRAW access violation might occur when color pickup
		// dialog is closed or About dialog box is closed.
		if (wParam == IDC_STATIC_OWNERDRAW) 
		{
			lpdis = (LPDRAWITEMSTRUCT) lParam; 
			// Here (lpdis->CtlID), without previous if, might occur access 
			// violation.
			if (lpdis->CtlID == IDC_STATIC_OWNERDRAW) 
			{
				// Standard painting procedure is to save system device 
				// context, brush (SaveDC, SelectObject) before using custom, 
				// and restore to saved when finished with painting by using 
				// SelectObject, RestoreDC.
				nSavedDC = SaveDC(lpdis->hDC); 

				hBrush =  CreateSolidBrush(g_clrBackgroundColor); 
				hOldBrush = (HBRUSH)SelectObject(lpdis->hDC, hBrush);
				FillRect(lpdis->hDC, &lpdis->rcItem, hBrush);
				SelectObject(lpdis->hDC, hOldBrush);

				DeleteObject(hBrush);
				RestoreDC(lpdis->hDC, nSavedDC);

				return TRUE;
			}
		}

		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}

	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
